Unit QSF7R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure QSF7R(var RINT1 :Real; var RINT2 :Real; var A :Real;
                var B :Real; F :Func_F1; RO :Real; FI :Real; E :Real;
                var ALFA :Real; var BETA :Real; var XA :Real;
                var E1 :Real; L1 :Integer; L2 :Integer);

implementation

procedure QSF7R(var RINT1 :Real; var RINT2 :Real; var A :Real;
                var B :Real; F :Func_F1; RO :Real; FI :Real; E :Real;
                var ALFA :Real; var BETA :Real; var XA :Real;
                var E1 :Real; L1 :Integer; L2 :Integer);
var
N,IL,D :Integer;
RINT3,RINT4,I,J,K,EPS,TAU,W,Z2,H,Z1,P,R,Q,V,T,S,Z,BA,BD,X,Y,H0,BB,BC,
   C,U,BF :Real;
NI :Boolean;
G :Array [0..4] of Real;
L :Array [0..4] of Real;
M :Array [0..4] of Real;
Q1 :Array [0..4] of Real;
BE :Array [0..6] of Real;
const
SYS059 :Real = 1.7E38;
HM :Real = 2.0E-10;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42;
begin
EPS := E;
XA := -SYS059;
IL := 1;
NI := ( A  > B );
if (  not ( (NI) ) ) 
 then goto _1;
C := A;
A := B;
B := C;
_1:
W := B-A;
if (  not ( (W  = 0.0) ) ) 
 then goto _2;
RINT1 := 0;
RINT2 := 0;
E1 := 0;
goto _42;
_2:
if ( BETA-ALFA ) < 0
 then goto _3
 else if ( BETA-ALFA ) > 0
       then goto _5
       else goto _4;
_3:
C := ALFA;
ALFA := BETA;
BETA := C;
goto _5;
_4:
ALFA := ALFA-HM;
BETA := BETA+HM;
_5:
ALFA := (ALFA-A)/W;
BETA := (BETA-A)/W;
TAU := (BETA-ALFA)/2;
if ( TAU-HM ) < 0
 then goto _6
 else if ( TAU-HM ) > 0
       then goto _7
       else goto _6;
_6:
TAU := HM;
_7:
Z2 := E/W;
H := 1;
N := 0;
Z1 := EPS/W;
_8:
P := 0;
E1 := 0;
RINT1 := 0;
RINT2 := 0;
_9:
if (  not ( (P  < BETA  ) and ( (P+H)  > ALFA  ) and ( H  > TAU) ) )
 then goto _10;
H := TAU;
if ( P  >= ALFA ) 
 then goto _10;
H := ALFA-P;
if ( H  < TAU ) 
 then H := TAU;
_10:
R := H/2.0;
Q := W*R;
V := Q*RO;
T := H*0.25;
for D:=1 to 5 do
 begin
  L[D-1] := F(A+W*(P+T*(D-1)));
_11:
 end;
_12:
if ( (L1+L2)  < 1.5  ) and ( V  <= 0.25 ) 
 then goto _13;
S := Abs(L[0]+L[4]-4.0*(L[1]+L[3])+6.0*L[2]);
goto _15;
_13:
I := (A+W*(P+R))*RO+FI;
for D:=1 to 5 do
 begin
  M[D-1] := L[D-1]*Sin(I);
  Q1[D-1] := L[D-1]*Cos(I);
_14:
 end;
I := M[0]+M[4]-4.0*(M[1]+M[3])+6.0*M[2];
S := Q1[0]+Q1[4]-4.0*(Q1[1]+Q1[3])+6.0*Q1[2];
S := EMax1(L1*Abs(I),L2*Abs(S));
_15:
S := S*R*0.42;
if ( Abs(S)-Z1 ) < 0
 then goto _21
 else if ( Abs(S)-Z1 ) > 0
       then goto _16
       else goto _16;
_16:
H := H/2.0;
if ( 64.0+H-64.0 ) < 0
 then goto _17
 else if ( 64.0+H-64.0 ) > 0
       then goto _20
       else goto _17;
_17:
if ( P ) < 0
 then goto _18
 else if ( P ) > 0
       then goto _19
       else goto _18;
_18:
if ( H/4.0 ) < 0
 then goto _19
 else if ( H/4.0 ) > 0
       then goto _20
       else goto _19;
_19:
XA := (P+A)*W;
P := P+2.0*H;
H := H*2.0;
goto _21;
_20:
L[4] := L[2];
L[2] := L[1];
R := H*0.5;
V := W*R*RO;
T := H*0.25;
U := P+T;
L[1] := F(A+W*U);
L[3] := F(A+W*(U+R));
goto _12;
_21:
E1 := E1+Abs(S);
I := (A+W*(P+R))*RO+FI;
Z := Sin(I);
BA := Cos(I);
Q := W*R;
BD := RO*Q;
BE[3] := Sin(BD);
BE[4] := Cos(BD);
if ( BD-0.33 ) < 0
 then goto _22
 else if ( BD-0.33 ) > 0
       then goto _23
       else goto _22;
_22:
BF := BD*0.5;
BE[5] := Sin(BF);
BE[6] := Cos(BF);
G[0] := 0.2666667;
G[1] := 0.7111111*BE[6];
G[2] := 0.1555556*BE[4];
G[3] := 0.7111111*BE[5];
G[4] := 0.1555556*BE[3];
goto _24;
_23:
BE[0] := 1.0/BD;
BE[1] := BE[0]*BE[0];
BE[2] := BE[1]*BE[1];
G[0] := 4.0*BE[1]*(BE[0]*(48.0*BE[1]-19.0)*BE[3]+3.0*(1.0-16.0*
    BE[1])*BE[4]);
G[1] := 32.0*BE[1]*(BE[0]*(5.0-12.0*BE[1])*BE[3]-(1.0-12.0*
    BE[1])*BE[4])/3.0;
G[2] := BE[0]*((3.0-46.0*BE[1]+96.0*BE[2])*BE[3]+2.0*BE[0]*
    (7.0-48.0*BE[1])*BE[4])/3.0;
G[3] := -16.0*BE[1]*((1.0-3.0*BE[1])*BE[3]+3.0*BE[0]*BE[4])/
    3.0;
G[4] := BE[0]*(BE[0]*(11.0-24.0*BE[1])*BE[3]-3.0*(1.0-8.0*
    BE[1])*BE[4])/3.0;
_24:
X := G[0]*L[2]+G[1]*(L[1]+L[3])+G[2]*(L[0]+L[4]);
Y := G[3]*(L[3]-L[1])+G[4]*(L[4]-L[0]);
RINT1 := RINT1+(Z*X+BA*Y)*R;
RINT2 := RINT2+(BA*X-Z*Y)*R;
P := P+H;
K := 1.0-P;
N := N+1;
if ( N-1 ) < 0
 then goto _26
 else if ( N-1 ) > 0
       then goto _26
       else goto _25;
_25:
H0 := H;
_26:
if ( 1.0+K/64.0-1.0 ) < 0
 then goto _27
 else if ( 1.0+K/64.0-1.0 ) > 0
       then goto _29
       else goto _27;
_27:
J := (Abs(F(B))+Abs(L[4]))*K/2.0;
if ( J-Z2 ) < 0
 then goto _33
 else if ( J-Z2 ) > 0
       then goto _28
       else goto _33;
_28:
E1 := E1+J;
goto _33;
_29:
L[0] := L[4];
if ( S-Z1/32.0 ) < 0
 then goto _30
 else if ( S-Z1/32.0 ) > 0
       then goto _31
       else goto _31;
_30:
H := 2.0*H;
_31:
if ( H-K ) < 0
 then goto _9
 else if ( H-K ) > 0
       then goto _32
       else goto _9;
_32:
H := K;
goto _9;
_33:
BB := EMax1(Abs(RINT1)*L1,Abs(RINT2)*L2);
BB := Z2*(1+BB);
if ( E1-BB ) < 0
 then goto _40
 else if ( E1-BB ) > 0
       then goto _34
       else goto _40;
_34:
if ( IL-1 ) < 0
 then goto _35
 else if ( IL-1 ) > 0
       then goto _35
       else goto _36;
_35:
BC := EMax1((Abs(RINT1-RINT3)/(1+Abs(RINT3))*L1),
    (Abs(RINT2-RINT4)/(1+Abs(RINT4))*L2));
if ( BC-Z2 ) < 0
 then goto _39
 else if ( BC-Z2 ) > 0
       then goto _36
       else goto _39;
_36:
RINT3 := RINT1;
RINT4 := RINT2;
IL := 2;
EPS := EPS/IntPower(2,5);
if ( XA+SYS059 ) < 0
 then goto _37
 else if ( XA+SYS059 ) > 0
       then goto _40
       else goto _37;
_37:
if ( EPS-1.E-15 ) < 0
 then goto _39
 else if ( EPS-1.E-15 ) > 0
       then goto _38
       else goto _39;
_38:
H := H0;
goto _8;
_39:
E1 := BC;
_40:
RINT1 := RINT1*W;
RINT2 := RINT2*W;
E1 := E1*W;
if (  not ( (NI) ) ) 
 then goto _41;
RINT1 := -RINT1;
RINT2 := -RINT2;
C := B;
B := A;
A := C;
_41:
ALFA := ALFA*W+A;
BETA := BETA*W+A;
_42:
end;

end.
